﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@using Microsoft.AspNetCore.Http;
@model CyberaniumModels.IRA
@{
    ViewData["Title"] = "Index";
}
<script src="~/Script/ApplicationManagement/IRA.js"></script>
<style>
    .boxcolor {
        margin-left: 60px;
        position: relative;
        height: 150px;
        width: 35px;
        background: #00b050;
        background: -moz-linear-gradient(bottom, #00b050 0%, #ffdc00 50%, #ff0000 100%);
        background: -webkit-linear-gradient(bottom, #00b050 0%,#ffdc00 50%,#ff0000 100%);
        background: linear-gradient(to top, #00b050 0%,#ffdc00 50%,#ff0000 100%);
    }

    .arrowicon1 {
        position: absolute;
        left: 30px;
        transform: rotate( -90deg);
    }

    .box {
        margin-bottom: 10px;
    }

    .box_head {
        background: #0091da;
        font-size: 14px;
        padding: 10px;
        color: #fff;
        text-align: center;
    }

    .box_in {
        display: flex;
        padding: 10px;
    }

        .box_in.prorisk {
            display: inherit;
            background: #f3f3f3;
        }

    .prorisk .largeText {
        width: 100%;
        text-align: center;
        font-size: 40px;
        padding: 5px 0px;
    }

    .smText {
        text-align: center;
        width: 100%;
        font-size: 14px;
    }
    .addApplications {
        padding: 0px 15px !important;
    }
    .prorisk{
        position:relative;
    }
        .prorisk > span {
            position: absolute;
            left: 20px;
            font-weight: bold;
            font-size: 12px;
        }
        .prorisk .high {
            bottom: calc(89% - 25px);  
        }
        .prorisk .Medium {
            bottom: calc(49% - 10px);
        }
        .prorisk .Low {
            bottom: calc(0% + 20px);
        }
        .prorisk .minVal {
            left: inherit;
            right: 8px;
            bottom: calc(0% + 20px);
        }
        .prorisk .maxVal {
            left: inherit;
            right: 8px;
            bottom: calc(89% - 25px);
        }
</style>
<style>
    .backtolist {
        color: #fff !important;
        cursor: pointer !important;
    }

    .table_control {
        float: inherit;
    }
</style>
<script>
    function fn_FinalScoreGrf() {
        var sum = 0;
        var count = 0;
        $('#DomainCritical2 tbody tr td .finalscoregrafclass').each(function (index,item) {
            debugger
            var score = parseFloat($(this).val());
            if (score > 0) {
                sum += score;
                count++;
            }
        })
        var str = isNaN((sum / count).toFixed(2)) ? 0 : (sum / count).toFixed(2);
        var result = Number(str).toFixed(2);
        $('#finalRiskScore').text(isNaN(parseFloat(result).toFixed(2)) ? 0 : parseFloat(result).toFixed(2) + '/25');
        $('.arrowicon1').css('bottom', 'calc(' + ((isNaN(parseFloat(result).toFixed(2)) ? 0 : parseFloat(result).toFixed(2)) * 3.85) + '% - 17px)');
    }
    $('.box').hide();
    $('.boxcolor').hide();


    function FinalAvgValue() {
        var html = '<td style="width:120px;background:#00a3a1">Final Risk Score</td>';
        var total = 0, length = 0;
        $('.rdth').each(function (i, element) {
            var riskDomainId = $(element).attr('id');
            var sum = 0;
            var count = 0;
            $('.Scoreclass' + riskDomainId).each(function (index, item) {
                var score = parseFloat($(item).find('input').val());
                if (score > 0) {
                    sum += score;
                    count++;
                }
            })
            var str = isNaN((sum / count).toFixed(2)) ? 0 : (sum / count).toFixed(2);
            var finalScore = Number(str).toFixed(2);
            html += '<td class="tdfinalscore">' + (isNaN(finalScore) ? 0 : finalScore) + '</td>'
            total += parseFloat(finalScore);
            length++;
        })
        $('#finalScore').html(html);
        var tdtotal = 0;
        var tdlength = 0;
        $('.tdfinalscore').each(function (i, e) {
            debugger
            var tdscore = parseFloat($(e).text());
            if (tdscore > 0) {
                tdtotal += tdscore;
                tdlength++;
            }
        })
        var finalRiskScore = parseFloat((tdtotal / tdlength).toFixed(2));
        $('#finalRiskScore').text(isNaN(finalRiskScore) ? 0 : finalRiskScore + '/25');
        $('.arrowicon1').css('bottom', 'calc(' + ((isNaN(finalRiskScore) ? 0 : finalRiskScore) * 3.85) + '% - 17px)');
        $('input').attr('readonly', 'readonly');
    }

    function AvgVal() {
        debugger;
        var html = '<td style="width:120px;background:#00a3a1">Final Risk Score</td>';
        var total = 0, length = 0;
        $('.rdth').each(function (i, element) {
            var riskDomainId = $(element).attr('id');
            var sum = 0;
            var count = 0;
            $('.Scoreclass' + riskDomainId).each(function (index, item) {
                var score = parseFloat($(item).find('input').val());
                if (score > 0) {
                    sum += score;
                    count++;
                }
            })
            $('#rd' + riskDomainId).val((isNaN((sum / count).toFixed(2)) ? 0 : (sum / count).toFixed(2)));
            var dcScore = parseFloat($('.RD_' + riskDomainId + ':last').val())
            var domainScore = parseFloat($('#rd' + riskDomainId).val())
            var finalScore = (dcScore * domainScore).toFixed(2);
            if (finalScore > 0) {
                length++;
            }
            html += '<td>' + (isNaN(finalScore) ? 0 : finalScore) + '</td>'
            total += parseFloat(finalScore);
        })
        $('#finalScore').html(html);
        var finalRiskScore = parseFloat((total / length).toFixed(2));
        $('#finalRiskScore').text(isNaN(finalRiskScore) ? 0 : finalRiskScore + '/25');
        $('.arrowicon1').css('bottom', 'calc(' + ((isNaN(finalRiskScore) ? 0 : finalRiskScore) * 3.85) + '% - 17px)');
        $('input').attr('readonly', 'readonly');
    }




    function fn_ShowFun(input1) {
        debugger
        var Orgname = $('#ChildOrgId option:selected').text();
        $('#preloader').show();
    /*    $(".selectOrganization").empty();*/
        $("#FunctionId").empty();
        $('#divDomainCriticalityScore2').hide();
        $('#processTree123').empty();
        $('.box').hide();
        $('.boxcolor').hide();
        var OrgID = $(input1).val();
        var html = '<option value="0">Select Function</option>';
        setTimeout(function () {
            $.ajax({
                url: "/Dashboard/Landing/BindFunctionProcess",
                type: "POST",
                async: false,
                data: { OrgID: OrgID, Orgname: Orgname, FunId: 0 },
                success: function (res) {
                    debugger
                    if (res.res1.length > 0) {
                        for (var i = 0; i < res.res1.length; i++) {
                            html += "<option value=" + res.res1[i].id + ">" + res.res1[i].functionName + "</option>";
                        }
                    }
                    $('#DomainCritical2').html(res.html);
                    $('#divDomainCriticalityScore2').show();
                    $('.box').show();
                    $('.boxcolor').show();
                    FinalAvgValue();
                },
                error: function (ex) {
                    console.log(ex.responseText);
                }
            })
            $("#FunctionId").html(html);
        },500);
   
    }

    function fn_ShowGetProcess(input1) {
        $('#finalScore').empty();
        $('#divDomainCriticalityScore2').hide();
        $('#processTree123').empty();
        $('#DomainCritical').empty();
        $('#DomainCritical2').empty();
        //$('#DomainCritical3').empty();
        $(".selectOrganization").empty();
        $('#processTree').empty();

        $('.box').hide();
        $('.boxcolor').hide();
        var FunID = $(input1).val();
        $.ajax({
            url: "/Dashboard/Landing/ProcessTree",
            type: "POST",
            data: { orgId: $('#ChildOrgId').val(), functionId: FunID },
            success: function (res) {
                debugger
                var html = "";
                for (var i = 0; i < res.functionList.length; i++) {
                    debugger
                    for (var j = 0; j < res.processList.length; j++) {
                        debugger
                        html += '<li><div><span class="text">' + res.processList[j].processName + '</span><a href="#" class="procesClass" onclick="GetDomainCriticalityScore(' + res.functionList[i].orgID + ', ' + res.functionList[i].id + ', ' + res.processList[j].id + ' , `' + res.processList[j].processName + '`, `' + res.processList[j].processOwner + '`, `' + res.processList[j].processDescription + '`);fn_ShowGetOrgCategory(' + res.functionList[i].orgID + ', ' + res.functionList[i].id + ', ' + res.processList[j].id + '); "><span class="icon"><i class="fa fa-caret-right fa-3x" style="padding-top:7px;"></i></span></a></div></li>';
                    }
                }
                $('.box').show();
                $('.boxcolor').show();
                $('#divDomainCriticalityScore2').show();
                $('#DomainCritical2').html(res.finalScore);
                $('#DomainCritical2').show();
                $('#processTree123').append(html);
                $('input').attr('readonly', 'readonly');
                fn_FinalScoreGrf();
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })
    }


    function fn_ShowGetOrgCategory(orgId, functionId, processId) {
        debugger
        $.ajax({
            url: "/Dashboard/Landing/OrgCategory",
            type: "POST",
            data: { orgId: orgId, functionId: functionId, processId: processId },
            success: function (res) {
                debugger
                if (res.html != "") {
                    $('#DomainCritical2').html(res.html);
                    AvgVal();
                    $('.box').show();
                    $('.boxcolor').show();
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })
    }

    function fn_ShowProcess(input) {
        $(".selectOrganization").empty();
        $("#Id").empty();
        var OrgID = $('#ChildOrgId').val();
        var FunId = $(input).val();
        $.ajax({
            url: "/Dashboard/Landing/BindFunctionProcess",
            type: "POST",
            data: { OrgID: OrgID, FunId: FunId },
            success: function (res) {
                debugger
                if (res.res1.length > 0) {
                    for (var i = 0; i < res.res1.length; i++) {
                        $("#Id").append("<option value=" + res.res1[i].id + ">" + res.res1[i].functionName + "</option>");
                    }
                    $(".selectOrganization").append(res.res);
                 
                }
                else {

                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })
    }


</script>


<style>
    h2.h2class {
        margin: 0;
        font-size: 17px;
        font-weight: 600;
    }

    .tabanchor p {
        background-color: #fff;
        width: 100%;
        float: left;
        font-size: 17px;
        font-weight: 600;
        line-height: 51px;
    }

    .tabanchor span {
        float: right;
        font-size: 15px;
    }

    /*.boxcolor {
        float: left;
        position: relative;
        height: 25px;
        width: 100%;
        background: #00b050;*/ /* Old browsers */
    /*background: -moz-linear-gradient(left, #00b050 0%, #ffdc00 50%, #ff0000 100%);*/ /* FF3.6-15 */
    /*background: -webkit-linear-gradient(left, #00b050 0%,#ffdc00 50%,#ff0000 100%);*/ /* Chrome10-25,Safari5.1-6 */
    /*background: linear-gradient(to right, #00b050 0%,#ffdc00 50%,#ff0000 100%);*/ /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
    /*}

    .arrowicon {
        position: absolute;
        bottom: -26px;
        left: 0px;
    }*/

    .btn_enabler {
        background: #61c1c1;
        border: none;
        width: 100%;
        text-align: center;
        padding: 12px 4px;
        color: #fff;
        margin-top: 15px;
    }




    .inputcheckboxlist ul {
        list-style-type: none;
    }

        .inputcheckboxlist ul li {
            display: inline-block;
            padding: 8px 8px;
        }

    input[type="checkbox"].customcheckbtn {
        display: none;
    }

        input[type="checkbox"].customcheckbtn + label {
            position: relative;
            padding: 5px 5px 5px 40px;
        }

            input[type="checkbox"].customcheckbtn + label:before {
                content: "";
                width: 27px;
                height: 27px;
                border-radius: 4px;
                border: solid 1px #ccc;
                background: #fff;
                position: absolute;
                left: 0;
                top: 2px;
                transition: 0.3s;
            }

            input[type="checkbox"].customcheckbtn + label:after {
                content: "";
                width: 12px;
                height: 6px;
                border-bottom: solid 3px #fff;
                border-left: solid 3px #fff;
                position: absolute;
                left: 8px;
                top: 10px;
                opacity: 0;
                transition: 0.3s;
                transform: rotate( -45deg );
            }


        input[type="checkbox"].customcheckbtn:checked + label:after {
            opacity: 1;
        }

        input[type="checkbox"].customcheckbtn:checked + label:before {
            border: solid 1px #0b1db2;
            background: #0b1db2;
        }

    #tblApplications td .clickIcon {
        width: 20px;
        height: 20px;
        display: block;
        background: #00a3a1;
        margin-left: auto;
        position: relative;
        cursor: pointer;
    }

        #tblApplications td .clickIcon::before {
            content: "";
            width: 2px;
            height: 12px;
            background: #fff;
            position: absolute;
            top: 4px;
            left: 50%;
            margin-left: -1px;
        }

        #tblApplications td .clickIcon::after {
            content: "";
            width: 12px;
            height: 2px;
            background: #fff;
            position: absolute;
            left: 4px;
            top: 50%;
            margin-top: -1px;
        }

        #tblApplications td .clickIcon.remove {
            background: #f00;
        }

            #tblApplications td .clickIcon.remove::before {
                display: none;
            }
</style>


<section>
    <div class="right_section">
        @Html.HiddenFor(x => x.OrgId)
        <div class="pb-2 mt-3 mb-2 border-bottom box_title pl-4">
            Process Dashboard
            <a class="backtolist" href="/Dashboard/Landing/Index">Back to Menu</a>
        </div>
        @Html.HiddenFor(x => x.OrgName)


        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="row">
                        <div class="col-md-4 col-sm-4 col-xs-6">
                            <label class="required">Organization</label>
                            <div class="select_box m_bottom">
                                @Html.DropDownListFor(m => m.ChildOrgId, Model.DdlParentOrg, "Select an Option", new { @class = "form-control m_no chosen-select", required = "required", onchange = "fn_ShowFun(this);" })
                            </div>
                        </div>
                        <div class="col-md-4 col-sm-4 col-xs-6">
                            <label class="required">Function</label>
                            <div class="select_box m_bottom">
                                @*@Html.DropDownListFor(m => m.ID, Model.DdlProcess, "Select an Option", new { @class = "form-control m_no chosen-select", required = "required", onchange = "fn_ShowGetProcess(this)" })*@
                                <select asp-for="FunctionId" asp-items="@(new SelectList(string.Empty))" class="form-control" onchange="fn_ShowGetProcess(this)">
                                    <option value="0">--Select--</option>
                                </select>
                            </div>
                        </div>
                    </div>
                    <div class="mb-2 border-bottom box_title pl-4"></div>
                    <div class="row">
                        <div class="col-sm-3">
                            <div class="boxgrey">
                                <div class="boxone">
                                    <div class="col">
                                        <ul class="orgmap" id="processTree123">
                                        </ul>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="col-sm-7 p-0">
                            <div class="addApplications" id="divDomainCriticalityScore2">
                                <div class="table_control">
                                    <table id="DomainCritical" class="table"></table>
                                </div>
                                <div class="table_control">
                                    <table id="DomainCritical2" class="table"></table>
                                </div>
                                <div class="table_control">
                                    <table id="DomainCritical312" class="table table-bordered"><tbody><tr id="finalScore"></tr></tbody></table>
                                </div>
                            </div>
                            @*<div class="addApplications" id="divMapEnabler">
                                    <div class="row p-1">
                                        <div class="col-2 p-2">
                                            <label>Process Name : </label>
                                        </div>
                                        <div class="col-6">
                                            <input class="form-control" id="_ProcessName" readonly />
                                        </div>
                                    </div>
                                    <div class="mx-5 mt-3 border-bottom box_title" style="border-bottom:1px solid #22a9b7 !important">Select Enabler</div>
                                    <div class="row justify-content-center">
                                        <div class="col-3"><button class="btn_enabler" onclick="ShowModalMapEnabler(10)">Application</button></div>
                                        <div class="col-3"><button class="btn_enabler" onclick="ShowModalMapEnabler(11)">IT Infrastructure</button></div>
                                        <div class="col-3"><button class="btn_enabler" onclick="ShowModalMapEnabler(7)">Location</button></div>
                                    </div>
                                    <div class="row justify-content-center">
                                        <div class="col-3"><button class="btn_enabler" onclick="ShowModalMapEnabler(6)" disabled>People</button></div>
                                        <div class="col-3"><button class="btn_enabler" onclick="ShowModalMapEnabler(1)" disabled>Governance</button></div>
                                    </div>
                                    <div class="row justify-content-center">
                                        <div class="col-6"><button class="btn_enabler" onclick="ShowModalMapEnabler(14)">Cloud</button></div>
                                    </div>
                                    <div class="row justify-content-center">
                                        <div class="col-6"><button class="btn_enabler" onclick="ShowModalMapEnabler(9)">Third Party</button></div>
                                    </div>
                                    <div class="row justify-content-center">
                                        <div class="col-6"><button class="btn_enabler" onclick="ShowModalMapEnabler(15)">Network</button></div>
                                    </div>
                                </div>*@
                        </div>
                        <div class="col-sm-2">
                            <div class="box">
                                <div class="box_head">
                                    Process Risk Score
                                </div>
                                <div class="box_in prorisk">
                                    <div class="largeText" id="finalRiskScore">0</div>
                                    @*<div class="smText">
                                        (Average of final risk scores across domain out of 25)
                                    </div>*@
                                </div>
                            </div>
                            <div class="box">
                                <div class="box_head">Risk -o- meter</div>
                                <div class="box_in prorisk">
                                    <span class="high">High</span>
                                    <span class="Medium">Medium</span>
                                    <span class="Low">Low</span>
                                    <span class=" maxVal">25</span>
                                    <span class=" minVal">1</span>
                                   
                                    <div class="boxcolor">
                                        <div class="arrowicon1" style="bottom:calc(0% - 17px);">
                                            <i class="fa fa-caret-up fa-3x" aria-hidden="true"></i>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<div class="modal fade" id="modalMapEnabler" tabindex="-1" role="dialog" aria-labelledby="modalMapEnablerTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-xl " role="document">
        <div class="modal-content">
            <div class="p-2 mb-2 border-bottom box_title">Map Enabler</div>
            <div class="modal-body py-0">
                <div class="row">
                    <div class="col-12">
                        <div class="inputcheckboxlist">
                            <input type="hidden" id="ConCatId" />
                            <input type="text" class="form-control" id="inputSearch" placeholder="search" onkeyup="SearchQuestionnaire(this,'#liQuestion')" />
                            <ul id="liQuestion"></ul>
                            <label class="m-0">Item not in list...</label>&nbsp;<a href="#" onclick="AddQuestionnaire()">Add more</a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <a class="btn btn-danger" data-dismiss="modal" href="#modalMapEnabler" onclick="$('#inputSearch').val('')">Close</a>
                <button type="button" class="btn btn-primary" onclick="SubmitProcessEnablerMap()">Save</button>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="modalAddQuestionnaire" tabindex="-1" role="dialog" aria-labelledby="modalAddQuestionnaireTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" style="width: 900px; max-width: 900px" role="document">
        <div class="modal-content">
            <div class="p-2 mb-2 border-bottom box_title">Map Enabler</div>
            <div class="modal-body">
                <div class="row">
                    <div class="col-12">
                        <div class="table_control">
                            <table class="table" id="tblApplications">
                                <thead>
                                </thead>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <a class="btn btn-danger" data-dismiss="modal" href="#modalAddQuestionnaire">Close</a>
                <button type="button" class="btn btn-primary" onclick="SaveQuestionnaire()">Save</button>
            </div>
        </div>
    </div>
</div>
